import { CfnRefElement } from './cfn-element';
import { Construct } from './construct';
export interface CfnMappingProps {
    readonly mapping?: {
        [k1: string]: {
            [k2: string]: any;
        };
    };
}
/**
 * Represents a CloudFormation mapping.
 */
export declare class CfnMapping extends CfnRefElement {
    private mapping;
    constructor(scope: Construct, id: string, props: CfnMappingProps);
    /**
     * Sets a value in the map based on the two keys.
     */
    setValue(key1: string, key2: string, value: any): void;
    /**
     * @returns A reference to a value in the map based on the two keys.
     */
    findInMap(key1: string, key2: string): string;
}
