import { IConstruct } from "./construct";
/**
 * Class for JSON routines that are framework-aware
 */
export declare class CloudFormationJSON {
    /**
     * Turn an arbitrary structure potentially containing Tokens into a JSON string.
     *
     * Returns a Token which will evaluate to CloudFormation expression that
     * will be evaluated by CloudFormation to the JSON representation of the
     * input structure.
     *
     * All Tokens substituted in this way must return strings, or the evaluation
     * in CloudFormation will fail.
     *
     * @param obj The object to stringify
     * @param context The Construct from which to resolve any Tokens found in the object
     */
    static stringify(obj: any, context: IConstruct): string;
}
